import 'package:dropbox_integration/Classes/Utils/API.dart';

class FoldersActions {

  final String userToken;
  FoldersActions(this.userToken);


  ///Create a folder at a given path.
  ///
  ///__Required Dropbox Scope: files.content.write__
  ///
  /// * `path` Path in the user's Dropbox to create.
  /// * `autorename` If there's a conflict, have the Dropbox server try to autorename the folder to avoid the conflict (default = False). 
  Future<String> createFolder(String path, {bool autorename = false, bool printDebug = false}) async 
    => API.apiOnlineRequest(
      'https://api.dropboxapi.com/2/files/create_folder_v2',
      {
        "path": path,
        "autorename": autorename
      },
      userToken,
      printDebug
    );

}