
import 'dart:convert';

import 'package:http/http.dart' as http;

class API {

  ///This is the function to call online dropbox api
  ///
  ///Return the body of the response as String in json format
  static Future<String> apiOnlineRequest(String linkApi, Map jsonBody, String userToken, bool printDebug) async {
    String body = json.encode(jsonBody);

    http.Response response = await http.post(
      linkApi,
      headers: {
        'Authorization': 'Bearer $userToken',
        'Content-Type': 'application/json',
      },
      body: body
    );

    if(printDebug){
      print(response.body);
    }

    return response.body;
  }

}